<?php
/*
Plugin Name: GigaOM Custom Post Type Factory Hello World Example
Plugin URI: http://GigaOM.com/
Version: a1
Author: Casey Bisson
Author URI: http://GigaOM.com/
*/

// a function to register our custom post type at the right moment
function go_cpt_helloworld()
{
	class GO_Cpt_Example extends GO_Cpt
	{
		function __construct()
		{
			// set the name used to refer to this post in code
			// max. 20 characters, can not contain capital letters or spaces
			// full details: http://codex.wordpress.org/Function_Reference/register_post_type#Parameters
			$post_type_name = 'go-helloworld';
	
			// create an array of post options
			// full details: http://codex.wordpress.org/Function_Reference/register_post_type#Arguments
			$post_type_definition = array(
				'labels' => array(
					'name' => 'Hello World Posts',
					'singular_name' => 'Hello World',
				),
				'supports' => array( 
					'title', 
					'excerpt', 
					'editor', 
					'thumbnail',
				),
				'public' => TRUE,
				'taxonomies' => array( 'category' , 'post_tag' ),
			);
	
			// call the parent constructor with these items
			parent::__construct( $post_type_name , $post_type_definition );
		}
	
		function metabox( $post , $meta )
		{
?>
		<p>
			<label for="<?php echo $this->get_field_id('video_url'); ?>">Video URL (YouTube, Vimeo, etc...)</label>
			<input type="text" name="<?php echo $this->get_field_name('video_url'); ?>" id="<?php echo $this->get_field_id('video_url'); ?>" placeholder="https://vimeo.com/31648478" value="<?php echo esc_url( $meta['video_url'] ); ?>" />
		</p>
<?php
		}
	
		function update( $new_meta , $old_meta )
		{
			// sanitize and validate the metadata before saving it here
			// understand and use WP's methods http://codex.wordpress.org/Data_Validation

			// initialize our return value
			$meta = array();

			// sanitize our new meta value and add it to the return array
			$meta['video_url'] = esc_url( $new_meta['video_url'] );

			// return the sanitized and validated metadata
			return $meta;
		}
	}

	// globalize the var you'll use to store your custom post type instance
	// then you can use you that global var to access the methods in templates and elsewhere
	global $go_cpt_example;

	// creating a new instance of your post type class registers it
	$go_cpt_example = new GO_Cpt_Example;
}

// hook that function to the register_post_types action
add_action( 'register_post_types' , 'go_cpt_helloworld' );
